## Update CounterAdjustment

### cURL

```
curl --request PUT \
  --url https://api.m3ter.com/organizations/{orgId}/counteradjustments/{id} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "counterId": "<string>",
  "accountId": "<string>",
  "date": "2022-01-04",
  "value": 1,
  "version": 123,
  "purchaseOrderNumber": "<string>"
}
'
```

### Python

```
import requests

url = "https://api.m3ter.com/organizations/{orgId}/counteradjustments/{id}"

payload = {
    "counterId": "<string>",
    "accountId": "<string>",
    "date": "2022-01-04",
    "value": 1,
    "version": 123,
    "purchaseOrderNumber": "<string>"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript

```
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    counterId: '<string>',
    accountId: '<string>',
    date: '2022-01-04',
    value: 1,
    version: 123,
    purchaseOrderNumber: '<string>'
  })
};

fetch('https://api.m3ter.com/organizations/{orgId}/counteradjustments/{id}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/counteradjustments/{id}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS => json_encode([
    'counterId' => '<string>',
    'accountId' => '<string>',
    'date' => '2022-01-04',
    'value' => 1,
    'version' => 123,
    'purchaseOrderNumber' => '<string>'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>
```

### Go

```
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.m3ter.com/organizations/{orgId}/counteradjustments/{id}"

payload := strings.NewReader("{\n  \"counterId\": \"<string>\",\n  \"accountId\": \"<string>\",\n  \"date\": \"2022-01-04\",\n  \"value\": 1,\n  \"version\": 123,\n  \"purchaseOrderNumber\": \"<string>\"}\n")

req, _ := http.NewRequest("PUT", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Response

#### Available Responses

- **200**: Returns the updated CounterAdjustment
- **4XX**: Client Error
- **5XX**: Server Error

#### Example Response

```
{
  "id": "<string>",
  "version": 123,
  "dtCreated": "2023-11-07T05:31:56Z",
  "dtLastModified": "2023-11-07T05:31:56Z",
  "createdBy": "<string>",
  "lastModifiedBy": "<string>",
  "counterId": "<string>",
  "accountId": "<string>",
  "date": "2023-12-25",
  "value": 123,
  "purchaseOrderNumber": "<string>"
}
```

#### Authorization

- **Authorization (string)**: header, required
  - m3ter supports machine to machine authentication using the `clientCredentials` OAuth2 flow.

### Path Parameters

- **orgId (string)**: required, UUID of the Organization.
- **id (string)**: required, UUID of the CounterAdjustment to update.

### Body Parameters

- **counterId (string)**: required, ID of the Counter used for the CounterAdjustment on the Account.
- **accountId (string)**: required, the Account ID the CounterAdjustment is created for.
- **date (string)**: required, the date the CounterAdjustment is created for the Account (in ISO-8601 date format).
- **value (integer<int32>)**: required, Integer Value of the Counter used for the CounterAdjustment.
- **version (integer<int64>)**: required, version number of the entity.
- **purchaseOrderNumber (string)**: optional, Purchase Order Number for the Counter Adjustment.
